/************************************************/
/* A very simple realization of growable string */
/************************************************/

#include <windows.h>

#define MAX_STRING_SIZE	2048

/* I DO HATE any unnecessary memory allocation so everything's global and static */
static char Buffer[MAX_STRING_SIZE];

//
// Empty the string
//
void StringEmpty()
{
	Buffer[0] = 0;
}

//
// Append a string
//
void StringAppend(char *Str)
{
	/* do we have any space in our buffer left for new string? */
	int TotalLen = lstrlen(Buffer) + lstrlen(Str) + 1;	/* +1 - count terminating zero */
	if(TotalLen > MAX_STRING_SIZE) RaiseException(STATUS_NO_MEMORY, EXCEPTION_NONCONTINUABLE, 0, 0);
	lstrcat(Buffer, Str);
}

//
// Make the string N bytes shorter
//
void StringMakeShorter(int N)
{
	int NewLen = lstrlen(Buffer) - N;
	if(NewLen >= 0) Buffer[NewLen] = 0;
}

//
// Get address of the string
//
char * StringGetString()
{
	return Buffer;
}